# -*- coding: utf-8 -*-

from ctypes import *

#valuer à tester
quantile = 1.65

#alias sur la DLL
ma_dll = cdll.LoadLibrary('Ma_DLL.dll')

#alias sur la fonction
fnorm = ma_dll.fnorm

#définition du type de sortie
fnorm.restype = c_double

#appel sur un exemple
print(fnorm(c_double(quantile)))

#comparaison avec la fonction de Scipy
#import scipy.stats as stats
#print(stats.norm.cdf(quantile))


import math
#implémentation Python de fnorm
def fnorm_python(q):
    #au cas où
    if (q == 0):
        return 0.5
    #valeur de espilon
    epsilon = 0.00001
    #selon le signe de q
    if (q < 0):
        deb = q
        fin = 0
    else:
        deb = 0
        fin = q
    #calculer une seule fois
    temp = 1.0/(math.sqrt(2.0*math.pi))
    #itérer
    surface = 0.0
    a = deb
    while (a < fin):
        b = a + epsilon
        if (b > fin):
            b = fin
        fa = temp * math.exp(-0.5 * (a**2))
        fb = temp * math.exp(-0.5 * (b**2))
        trapeze = epsilon * (fa + fb)/2.0
        surface = surface + trapeze
        a = b
    if (q < 0):
        return 0.5-surface
    else:
        return 0.5+surface

#vérification
print(fnorm_python(quantile))

#comparaison - à saisir directement dans la console
#%timeit fnorm(c_double(2.35))
#%timeit fnorm_python(2.35)