unit UTrapeze;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

//integration - trapèze
function trapeze_normale(a,b: double): double; cdecl;

//fonction de répartition de la loi normale
function fnorm(const q: double): double; cdecl;

implementation

function trapeze_normale(a, b: double): double; cdecl;
var x,x_suivant,temp,fx,fx_suivant: double;
    surface,trapeze: double;
const epsilon: double = 0.00001;
begin
 //vérifier a et b
  if (b < a)
   then trapeze_normale:= 0.0
   else
     begin
       //une seule fois
       temp:= 1.0/(sqrt(2.0*Pi));
       //itérer
       surface:= 0.0;
       x:= a;
       while (x < b) do
        begin
         x_suivant:= x + epsilon;
         if (x_suivant > b) then x_suivant:= b;
         fx:= temp * exp(-0.5 * sqr(x));
         fx_suivant:= temp * exp(-0.5 * sqr(x_suivant));
         trapeze:= epsilon * (fx + fx_suivant)/2.0;
         surface:= surface + trapeze;
         x:= x_suivant;
        end;
       //valeur à retourner
       trapeze_normale:= surface;
     end;
end;

function fnorm(const q: double): double; cdecl;
begin
  //au cas où
  if (q = 0)
   then fnorm:= 0.5
   else
     //selon que q est positif ou négatif
     if (q < 0.0)
      then fnorm:= 0.5 - trapeze_normale(q,0.0)
      else fnorm:= 0.5 + trapeze_normale(0.0,q);
end;

end.

